#! /usr/bin/env python
# -*- coding: UTF-8 -*-/**-
# main window servocine
from Tkinter import *
from tkSnack import *
import  tkFileDialog, tkMessageBox, tkSimpleDialog,  webbrowser, os
import pickle,  os,  sys
import Calc, Gui
version="29/4/2008"
#check install

#global variables
modelfilename =""
root = Tk()
initializeSnack(root)
continu = False
txlive=IntVar()
txparam= Calc.TX()  # all the parameters , transmitter, servos, linkages ....
txSignal=Calc.TXsignal(txparam) # signal processing
sum=Gui.summaryShow(root, txSignal,  txparam)
print  txSignal.snd.info()
print "Version="+version

#menu File
def srvOpen():
    global txparam, modelfilename, sum
    modelfilename=tkFileDialog.askopenfilename(initialdir="Models",defaultextension=".srv")
    if len(modelfilename)==0:return
    modelfile =open(modelfilename, "r")
    txparam=pickle.load(modelfile)
    sum=Gui.summaryShow(root, txSignal,  txparam)
    sum.paint()
    
def srvSaveAs():
    global txparam,modelfilename
    modelfilename=tkFileDialog.asksaveasfilename(initialdir="Models",defaultextension=".srv")
    txparam.modelfilename=modelfilename
    modelfile=open(modelfilename, "w")
    print "Save to"+modelfilename
    pickle.dump(txparam,modelfile)
def srvExit():
    if len(txparam.modelfilename) > 3:
        modelfile=open(modelfilename, "w")
        print "Save to"+modelfilename
        pickle.dump(txparam,modelfile)
    root.destroy()
def callTXparam():
    d= Gui.TX(root, txparam)
    sum.paint()
    root.wait_window()

def callTXrecord():
    #tx=Calc.TXsignal(txparam)
    txSignal.record()
    id = root.after(Calc.TSAMPLE,process) # after the time TTSAMPLE, stop the recording and process
def callTXlive():
    global continu
    continu=int(txlive.get())
    if continu==True: callTXrecord()
def callTXtest():  
    txSignal.record()  
    id = root.after(Calc.TSAMPLE,TXtestShow)
def TXtestShow():
   Gui.TXtest(txSignal)

    
def process():
    global sum
    #processing a sound sample
    txSignal.stopRecord() 
    if txparam.PCM==False:
        txSignal.sync()
    else :
        txSignal.syncPCM()
        
    sum.paintVar()
    sum.draw() #draw the servo cinematic, if needed
    root.update_idletasks()
    if continu ==True:
        txSignal.snd.flush()
        txSignal.record() 
        id = root.after(Calc.TSAMPLE,process) # repeat getSnd    
def callhelp():
    url="file://"+os.getcwd()+"/Help/Fr/index.html"
    webbrowser.open_new(url)
    root.wait_window()    
def callAbout():   
    tkMessageBox.showinfo("About ServoSimu", "Version="+version+"\n http://users.skynet.be/robert.magda/")
# make the menu
root.title(" ServoSimu")
menu = Menu(root)
root.config(menu=menu)
menuProjet = Menu(menu)
menu.add_cascade(label="Projet", menu=menuProjet)
menuProjet.add_command(label="Open...", command=srvOpen)
menuProjet.add_command(label="Save As", command=srvSaveAs)
menuProjet.add_command(label="Exit", command=srvExit)
menuTX = Menu(menu)
menu.add_cascade(label="TX", menu=menuTX)
menuTX.add_command(label="Tx param", command=callTXparam)
menuTX.add_command(label="Tx record", command=callTXrecord)
menuTX.add_checkbutton(label="Tx Live",variable=txlive,  onvalue=True,  offvalue=False,  command=callTXlive)
menuTX.add_command(label="Tx test", command=callTXtest)

menuHelp = Menu(menu)
menu.add_cascade(label="Help", menu=menuHelp)
menuHelp.add_command(label="Documentation", command=callhelp)
menuHelp.add_command(label="About", command=callAbout)


sum.paint()
mainloop()

