#! /usr/bin/env python
# -*- coding: UTF-8 -*-/**-
# Newton interpolation method
# the function newton(f,xi) returns a solution of f(x)=0, starting the iteration from xi
#  f is  a function of one argument 
# the value of this argument is "around" 1 ( between 0.1 and 10, not several magnitudes away from  the unity)
#
#tip: In Python, functions are first-class objects that can be created and passed around dynamically.

# throws an error


def solver( f, xi) :   
    x1= xi #initial value
    y1= f(x1)
    ecart = abs(y1)
    n=1000
    while ( ecart> 0.001):
        n=n-1
        if n<0:
            #print "Error in the iteration"
            raise Exception , "Newton-Iteration error"
        if x1>0:
            x2=x1 * 0.999
        else:
            x2=x1+0.01
        y2 =f(x2)
        delta=(y1-y2)/(x1-x2) # this is f'(x)
        x1 = x1-(y1/delta)
        y1 = f(x1)
        ecart = abs(y1)
        #print "x = %5.1f delta= %5.2g ecart=%5.1f " %(x1, delta, ecart) # debudg the iterations
    return x1
def sample(x):
    return x**2 -2   # find x for x**2=2
if __name__ == '__main__':
    #raise Exception ,"Test exeception"
    print solver(sample,  1.0)   # do _it with uncomment of the print statement  
